# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class ListAppRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[str] = None
        self.page_token: Optional[str] = None

    @staticmethod
    def builder() -> "ListAppRequestBuilder":
        return ListAppRequestBuilder()


class ListAppRequestBuilder(object):

    def __init__(self) -> None:
        list_app_request = ListAppRequest()
        list_app_request.http_method = HttpMethod.GET
        list_app_request.uri = "/open-apis/apaas/v1/apps"
        list_app_request.token_types = {AccessTokenType.USER}
        self._list_app_request: ListAppRequest = list_app_request

    def page_size(self, page_size: str) -> "ListAppRequestBuilder":
        self._list_app_request.page_size = page_size
        self._list_app_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "ListAppRequestBuilder":
        self._list_app_request.page_token = page_token
        self._list_app_request.add_query("page_token", page_token)
        return self

    def build(self) -> ListAppRequest:
        return self._list_app_request
