# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .employees_international_assignment_req import EmployeesInternationalAssignmentReq


class CreateEmployeesInternationalAssignmentRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.client_token: Optional[str] = None
        self.user_id_type: Optional[str] = None
        self.department_id_type: Optional[str] = None
        self.request_body: Optional[EmployeesInternationalAssignmentReq] = None

    @staticmethod
    def builder() -> "CreateEmployeesInternationalAssignmentRequestBuilder":
        return CreateEmployeesInternationalAssignmentRequestBuilder()


class CreateEmployeesInternationalAssignmentRequestBuilder(object):

    def __init__(self) -> None:
        create_employees_international_assignment_request = CreateEmployeesInternationalAssignmentRequest()
        create_employees_international_assignment_request.http_method = HttpMethod.POST
        create_employees_international_assignment_request.uri = "/open-apis/corehr/v2/employees/international_assignments"
        create_employees_international_assignment_request.token_types = {AccessTokenType.TENANT}
        self._create_employees_international_assignment_request: CreateEmployeesInternationalAssignmentRequest = create_employees_international_assignment_request

    def client_token(self, client_token: str) -> "CreateEmployeesInternationalAssignmentRequestBuilder":
        self._create_employees_international_assignment_request.client_token = client_token
        self._create_employees_international_assignment_request.add_query("client_token", client_token)
        return self

    def user_id_type(self, user_id_type: str) -> "CreateEmployeesInternationalAssignmentRequestBuilder":
        self._create_employees_international_assignment_request.user_id_type = user_id_type
        self._create_employees_international_assignment_request.add_query("user_id_type", user_id_type)
        return self

    def department_id_type(self, department_id_type: str) -> "CreateEmployeesInternationalAssignmentRequestBuilder":
        self._create_employees_international_assignment_request.department_id_type = department_id_type
        self._create_employees_international_assignment_request.add_query("department_id_type", department_id_type)
        return self

    def request_body(self,
                     request_body: EmployeesInternationalAssignmentReq) -> "CreateEmployeesInternationalAssignmentRequestBuilder":
        self._create_employees_international_assignment_request.request_body = request_body
        self._create_employees_international_assignment_request.body = request_body
        return self

    def build(self) -> CreateEmployeesInternationalAssignmentRequest:
        return self._create_employees_international_assignment_request
